
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27, 16, 2);

//---MAX6675 functions---//
double max6675_read_temp (int CLK, int CS, int SO)
{ char i;
  int tmp = 0;
  digitalWrite(CS, LOW); //CS = 0;                            //Stop a conversion in progress
  asm volatile
  (
    " nop"        "\n\t"
  );
  for (i = 15; i >= 0; i--)
  { digitalWrite(CLK, HIGH);
    asm volatile
    (
      " nop"        "\n\t"
    );
    if ( digitalRead(SO))
      tmp |= (1 << i);
    digitalWrite(CLK, LOW);
    asm volatile
    (
      " nop"        "\n\t"
    );
  }
  digitalWrite(CS, HIGH);
  if (tmp & 0x4) {
    return NAN;
  } else
    return ((tmp >> 3)) * 0.25;
}
//---MAX6675 functions---//


int TempBottom;
int SetTempBottom;
#define PinBottom 4
#define thermoSO 7
#define thermoCS 8
#define thermoCLK 9
#define PinPlus 5
#define PinMinus 6
//byte PeriodReadTemp = 0;
#define SENSOR_SAMPLING_TIME 500
unsigned long nextRead;
const byte DESIRED_WIDTH = 3;
void setup() {
  //Serial.begin(9600);
  SetTempBottom = 0;
  pinMode(PinPlus, INPUT_PULLUP);
  pinMode(PinMinus, INPUT_PULLUP);
  pinMode(PinBottom, OUTPUT);
  digitalWrite(PinBottom, LOW);
  pinMode(thermoCS, OUTPUT);
  pinMode(thermoCLK, OUTPUT);
  pinMode(thermoSO, INPUT);
  lcd.begin();
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print(" THERMOSTATING ");
  lcd.setCursor(1, 1);
  lcd.print("BOTTOM  HEATER");
  delay(5000);
  lcd.clear();
}
String addZeroes(const String& src, byte pad)
{
  if (src.length() >= pad)
    return src;
  String result;
  byte add = pad - src.length();
  while (add--)
    result += "0";
  result += src;
  return result;
  nextRead = millis();
}
void loop() {
  lcd.setCursor(0, 0);
  lcd.print("HEATING  CONTROL");
  if (millis() > nextRead)
  {
    nextRead = millis() + SENSOR_SAMPLING_TIME;
    TempBottom = (max6675_read_temp (thermoCLK, thermoCS, thermoSO));
  }
  lcd.setCursor(0, 1);
  lcd.print("REAL " + (addZeroes(String(TempBottom), DESIRED_WIDTH)));
  lcd.setCursor(9, 1);
  lcd.print("INS " + (addZeroes(String(SetTempBottom), DESIRED_WIDTH)));
  if (digitalRead(PinPlus) == LOW) {
    SetTempBottom++;
    delay(200);
  }
  if (digitalRead(PinMinus) == LOW) {
    SetTempBottom--;
    delay(200);
  }
  if (SetTempBottom <= 0) {
    SetTempBottom = 0;
  }
  if (SetTempBottom >= 500) {
    SetTempBottom = 500;
  }
  if (SetTempBottom > TempBottom) {
    digitalWrite(PinBottom, HIGH);
  }
  if (SetTempBottom <= TempBottom) {
    digitalWrite(PinBottom, LOW);
  }
}
